
#include "stdafx.h"

//int main(int argc, char* argv[])
#include<conio.h>
#include<stdio.h>
#include<stdlib.h>
#include<windows.h>


//---------------------------------------------
//DA ԶУ 
//wwlab 2008/9/12  V1.0
//by york wang

long mDACAL_EEPROM_WR2CH(HANDLE hDevice, long *zdata,long *fdata);
long mDACAL_EEPROM_RD2CH(HANDLE hDevice, long *cdata);
long mDACAL_ALL(HANDLE hDevice, long *zdata, long *fdata);

//--------------------------based function ----------------------------
//
//                        User Must Change all the Base Function
//-----------------------------------------------------------------------
#include"AC6613.h"
#include"dacal.h"


//for USER function
//------------------------------------------------------------------------------

//DA CAL дeeprom
//zdata DA ݣ˳: ------ch0 -------    ------ch1------ 
//                         zg0  zg1  zg2 zg3    zg1 zg2 zg3 zg4

//fdata DA ݣ˳: ------ch0 -------    ------ch1------ 
//                         fg0  fg1  fg2 fg3    fg0 fg1 fg2 fg3

// 1,2,3,4 ʾDAΧdga, =0-2 for ac6613
long DACAL_EEPROM_WR2CH(HANDLE hDevice, long *zdata,long *fdata)
{
  	return  mDACAL_EEPROM_WR2CH(hDevice, zdata, fdata);
}


//cal DA 
//special for AC6613!!!!!
//dach=0,1
//dag =0,1,2
long DACAL_ALL(HANDLE hDevice, long *zdata, long *fdata)
{
   return mDACAL_ALL(hDevice, zdata, fdata);
}


//read DA out voltage back
//back voltage at: mV
//auto AD gain using B5v B10V
double DACAL_ADV(HANDLE hDevice, long dach)
{
   double v;
   long adch;
   long adg;
   long dd;

#define adg_b5 2
#define adg_b10 3
   
     adg=adg_b5; //b5V
     
	 adch=dach+4;  //for ac6613 calch 4,5 is DA
        dd=AC6613_AD_CSAM(hDevice,adch,adg);

     if(dd>4094) //+full
	     adg=adg_b10; //B10V   	 


	 if(dd<1)  //-full
		 adg=adg_b10; //B10V   	 

	 long i=0;
	 //sam 10 average

	 dd=0;
	 for(i=0;i<10;i++)
		 dd+=AC6613_AD_CSAM(hDevice,adch,adg);

	 dd=dd/i;

     //convert to voltage
     v=(double)(dd-2048)/2048.0;

	 v=(adg==adg_b5) ? v*5000.0 : v*10000.0;

	 

	 return v;
}

// EEPROM , not using !!!!
// cdata ݶ壺
// zg0 fg0 zg1 fg1 zg2 fg2 zg3 fg3   <----------DAch0
// zg0 fg0 zg1 fg1 zg2 fg2 zg3 fg3 <----------DAch1
long DACAL_EEPROM_RD2CH(HANDLE hDevice, long *cdata)
{
   return mDACAL_EEPROM_RD2CH(hDevice, cdata);
}





//------------------------------------------------------------------------------

//*************************************************************************************
// my basic funtion


//set da data
void DACAL_DA(HANDLE hDevice, long dach, long dadata)
{


   AC6613_DA_CSET(hDevice,dach,dadata);   //set DA data with no check data function

}

//set da out gain
void DACAL_DA_Gain(HANDLE hDevice, long dach, long dagain)
{


   AC6613_DA_Mode(hDevice,dagain,dagain);   //set DA data with no check data function

}



//------------------------------------------------------
//cal DA 
//special for AC6613!!!!!
//dach=0,1
//dag =0,1,2
long mDACAL_ALL(HANDLE hDevice, long *zdata, long *fdata)
{
    
	
	 
  	
    long dach;
    long dag,daf,daz;
	
    
	//------------------------CAL  ---------------------
  for(dag=0;dag<3;dag++)
  {
	for(dach=0;dach<2;dach++)
	{
	   
	  // printf("\n---------------------------------\n");
	   //cal z
	   daz=DACAL_CAL_Z(hDevice,dach,dag);
	
	   
	   //cal f
       daf=DACAL_CAL_H(hDevice,dach,dag,daz);

	fdata[dach*4+dag]=daf;
    zdata[dach*4+dag]=daz;

    //printf("CH:%d  G=%d by fun daz=%d daf=%d\n",dach,dag,daz, daf);

	}
  }
  
  return 0;
}


//---------------------------------------------------------------------
//write cal data to EEPRM
//!!! only for 2DA and max 4 Gain step/ch
//daz  ch0: z5 z10 zb5 zb10   ch1: .....
long mDACAL_EEPROM_WR2CH(HANDLE hDevice, long *zdata,long *fdata)
{

   long idata[512];
//   long cdata[512];
   long dag,dach;
   long i,j;

   //write to eeprom
//seq:
//    0   1   2   3   4   5   6  7
//ch0 z5 f5  z10 f10 zb5 fb5  nc nc     //total 8byte
//    8  9  10  11  12  13   14   15
//ch1 z5

	for(i=0;i<17;i++)
			idata[i]=0;

	//set data to idata
	for(dach=0;dach<2;dach++)
	{
        for(dag=0;dag<3;dag++) 
		{
		    i=dach*8+dag*2;
			idata[i]=zdata[dach*4+dag];
			i++;
			idata[i]=fdata[dach*4+dag];
		}


	}

	
    //set chk sum
	j=0;
    for(i=0;i<16;i++)
           j+=idata[i];

	idata[16]=j & 0xff;

    DACAL_UpdateCAL(hDevice,idata);
	
	//------------------------user changed -----------------------------	
	//adr=0, num=17 
    i=AC6613_EEPROM_CWR(hDevice,0,32,idata);

	if(i<0)
		return -1;

	


	  return 0;
}


//read cal data from EEPROM
// if chk ok return chk sum , else return -1
long mDACAL_EEPROM_RD2CH(HANDLE hDevice, long *cdata)
{

	
	long i,j;

	
//------------------------user changed -----------------------------	
	i=AC6613_EEPROM_CRD(hDevice,0,32,cdata);

	if(i!=0)
		return -2;

	//chk sun
	j=0;
    for(i=0;i<16;i++)
       j+=cdata[i];

    j=j & 0xff;


    if(j!=cdata[16])
		return -1;
	

	DACAL_UpdateCAL(hDevice,cdata);

	return j; //chk sum

}


//---------------------------------------------------------------
//if cal any da call this or DACAL_EEPROM_WR
//update cal data
long DACAL_UpdateCAL(HANDLE hDevice, long *idata)
{

   
   long cdata[512];
   long i;


    

//------------------------user changed -----------------------------	
	//renew cal data in buffer
	AC6613_RDCAL(hDevice,cdata);

	//from 50 is dadata !!!!!!!!! for AC6613
	//please DLL OpenDevice
	  for(i=0;i<17;i++)
		 cdata[50+i]=idata[i];
//------------------------user changed -----------------------------	

    AC6613_WRCAL(hDevice,cdata);

	  return 0;
}





//------------------------------------------------- user func ---------------------------------------------

//read DA voltage back data from ad
//adgain:0 1 2 3 via 5/10/B5/B10V input 
//dach is for AD to sam ch for DA out
//dagain : is using for AD to deside using gain of AD
//return data is 10 average
long DACAL_AD(HANDLE hDevice, long dach, long dagain)
{

      long i=0;

	  long adg;
	  long adch;

	  //da at csam ch 4,5
	  adch=(dach==0) ? 4 : 5;  //AC6613 ch

	  switch(dagain)
	  {
			case 0: //da 5v
				adg=0;
				break;
			case 1: //da 10v
				adg=1;
				break;

			case 2: //B5v
				adg=2;
				break;

			case 3: //B10v
				adg=3;
				break;

			default : adg=0;
	  }
   

	  long add;

	  add=0;

	  Sleep(1); //waiting delay
	  for(i=0;i<10;i++)
         add+=AC6613_AD_CSAM(hDevice,adch,adg);



	  return add/i;
}

//end bas function
//--------------------------------------------------------------

//*************************************************************************************




//cal high out

long DACAL_CAL_H(HANDLE hDevice, long dach, long dag , long daz)
{


    long i;
	long chksign;
    long daf;
    long dadata;

	//max of DA out data
#define dmax  4095
    
	DACAL_DA_Gain(hDevice,dach,dag); //set da out mode

	//delay
     Sleep(1);  //witing DA stable
	
	daf=0;

	long delta;
	
	delta=10;

	//firat big step tuning
	do{

        chksign=0;  //sign
        
		daf=daf+delta;
		//set 
		dadata=dmax; //max
		dadata=(dadata*(dmax-daf))/dmax+daz;
		
		if(dadata>dmax)
             dadata=dmax;

		DACAL_DA(hDevice,dach,dadata);
    
		//sam 
		i=DACAL_AD(hDevice,dach,dag);
		
	   //  printf("CAL DA H ad=%d\n",i);


		if(i<4095)
		{
		   chksign=1;   //break;
		}




		if(daf>255)
			break;
        

	}while(chksign==0);
    

	//fine step tuning
	daf=daf-(delta*2);  //let full more great
	
	delta=1;

	do{

        chksign=0;  //sign
        
		daf=daf+delta;
		//set 
		dadata=dmax; //max
		dadata=(dadata*(dmax-daf))/dmax+daz;
		
		if(dadata>dmax)
             dadata=dmax;

		DACAL_DA(hDevice,dach,dadata);
    
		//sam 
		i=DACAL_AD(hDevice,dach,dag);
		
	   //  printf("CAL DA H ad=%d\n",i);


		if(i<4095)
		{
		   chksign=1;   //break;
		}




		if(daf>255)
			break;
        

	}while(chksign==0);
    

	daf=daf-delta;  //let full more great


	daf=(daf<0)? 0 : daf; 

    if(chksign==0)
	//not cal result or can't be get enougth of daz
	{
          
       return -1;
	}


	return daf;
}


	
//cal 0	  
long DACAL_CAL_Z(HANDLE hDevice, long dach, long dag )
{


    long i;
	long chksign;
    long daz;
	long daf;
    long dadata;
	long delta;
    
	DACAL_DA_Gain(hDevice,dach,dag); //set da out mode

	
	Sleep(1);  //witing DA stable

	daz=0;
	daf=0;
	delta=10;
	
	do{

        chksign=0;  //sign
        
		
		//set 
		dadata=daz;
		DACAL_DA(hDevice,dach,dadata);
    
		//sam BIP mode 10V
		i=DACAL_AD(hDevice,dach,3);
        
		//printf("CAL DA L ad=%d\n",i);
		switch(dag)
		{
		  case 0:  //5V
			  {
				if(i>2047)
				{
				  chksign=1;   //break;
				}
				break;
			  }

		  case 1: 
			  {
				  //10v
				if(i>2047)
				{
				  chksign=1;   //break;
				}
				break;
			  }
            
			case 2:  //B5v
				{
					if(i>1023)
					{
						chksign=1;   //break;
					}
					break;
				}

			case 3:
			{
              return -1;
			  break;
			}

		}


		if(daf>255)
			break;
        
		daz+=delta;
        

	}while(chksign==0);
    
	daz=daz-(delta*2);
    chksign=0;  //sign
	delta=1;
	
	do{

        chksign=0;  //sign
        
		
		//set 
		dadata=daz;
		DACAL_DA(hDevice,dach,dadata);
    
		//sam BIP mode 10V
		i=DACAL_AD(hDevice,dach,3);
        
		//printf("CAL DA L ad=%d\n",i);
		switch(dag)
		{
		  case 0:  //5V
			  {
				if(i>2047)
				{
				  chksign=1;   //break;
				}
				break;
			  }

		  case 1: 
			  {
				  //10v
				if(i>2047)
				{
				  chksign=1;   //break;
				}
				break;
			  }
            
			case 2:  //B5v
				{
					if(i>1023)
					{
						chksign=1;   //break;
					}
					break;}

			case 3:
			{
              return -1;
			  break;
			}

		}


		if(daf>255)
			break;
        
		daz+=delta;
        

	}while(chksign==0);
    
	
	//keep last data
	daz--;

	 if(daz<0)
		 daz=0;
   
    if(chksign==0)
	//not cal result or can't be get enougth of daz
	{
          
       return -1;
	}


	return daz;
}


  
	
	 