// ts6613.cpp : Defines the entry point for the console application.
//
// ts6610e.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"



//int main(int argc, char* argv[])
#include<conio.h>
#include<stdio.h>
#include<stdlib.h>

#include<math.h>




//Ӧʾüض̬ӿ
#include<windows.h>
#pragma comment(lib,"AC6613.lib")

#include"AC6613.h"
#include"dacal.h"

HANDLE hDevice;

#include <winioctl.h>
#include "ac6613ioctl.h"  //6610 self include



void setch(long stch,long endch,long adg,long bip,long sidi);


unsigned char eepdata[80];
char etmp[80];
long idata[512];
long wdata[512];    
long addata[0x5000000];
long cdata[200];
	
// ts6610e.cpp : Defines the entry point for the application.


//daop: 0 nothing / 1: write data to ram / 2: set len /3:set timer

long da_setmode(long dag0,long dag1, long daop, long wave_eb)
{
	//set mode op=3
	long damode=0;

	dag0=dag0 & 3;
	dag1=dag1 & 3;
	damode=dag0;
	damode=damode | (dag1<<2);

	//set op
	damode=damode | (daop<<4);

	//set wave eb
	wave_eb=wave_eb & 1;
	damode=damode | (wave_eb<<7);

	printf("damode=%x\n",damode);
	
	return AC6613_outb(hDevice,0x12,damode);

}


//counting voltage
double adv(long adg, long data)
{
  double aa;
    
  if(adg==0)
      aa=(double)data*5000.0/4095.0;

  if(adg==1)
      aa=(double)data*10000.0/4095.0;

  if(adg==2)
      aa=(double)(data-2047)*5000.0/2048.0;

  if(adg>2)
      aa=(double)(data-2047)*10000.0/2048.0;

  return aa;


}


long CAL_ch(long cch, long adg)
{
	
	long sidi,bip;
	long stch,endch;
    long ch;

	sidi=0;
	bip=0;
    	
	
	//sidi=1 cha4=1 for cal
	//ch=0,1 sw out
	//ch=2,3 gnd/ref5
	//ch=4,5 da0,da1
	

	sidi=1;
	stch=cch | 0x10;   //cha4=1
	endch=stch;

	adg=adg & 0x3;
    sidi=sidi & 1;
	bip=bip & 1;

	//set ch
	ch=stch & 0x3f;
	ch=ch | (endch<<8);
    
	//set adg
	ch=ch | (adg<<6);
	
	//set sidi
	ch= ch | (sidi<<15) ;
	
    //set bip
	ch=ch | (bip<<14);

	return ch;
}



int main(int argc, char* argv[])
{

	//fifo
	long ff=0;
	long kfifost=0;
	long flen=0;
	long fcnt=0;
	

	int i=0;
	int j=0;
    double a;
    long dadata;
    long dach;
	long dag=0;

	
	long sidi,adg,bip;
	long stch,endch;
    long ch;
    long tdata=0;

    double v;

    sidi=0;
	ch=0;
	adg=0;
	bip=0;
	stch=0;
	endch=0;


	printf("Testing AC6613L..................wwlab (c) 2013.11.\n");
	
	hDevice=AC6613_OpenDevice(0);

	if(hDevice==INVALID_HANDLE_VALUE)
	{
        printf("error open AC6613's Device or Hardware!");
		getch();
		exit(0);
	}

    printf("Ok! open Device=%xH\n",hDevice);

	printf("read SN=%x\n",AC6613_inw(hDevice,0x20));// | (AC6613_inb(hDevice,0x21)<<8));

	printf("--------------------------------------------------\n");
  
	
	
	//set DIO

	printf("set Do=0x55AA......");
	AC6613_DO(hDevice,0x55aa);
	
	printf("Read Back DI=%x\n",AC6613_DI(hDevice));
	
	printf("set Do=0xAA55......");
	AC6613_DO(hDevice,0xaa55);
	
	printf("Read Back DI=%x\n",AC6613_DI(hDevice));
	
	long adch;

	adch=CAL_ch(3,1);
	i=AC6613_sam(hDevice,adch,cdata);

	printf("ref:%d   g=1\n",i);
	getch();



//********************************************************
	AC6613_RDCAL(hDevice,cdata);
	
	printf("\nread cal After cal op.....\n");
    for(i=0;i<20;i++)
		printf("%10d",cdata[i]);

	printf("\n");
	getch();
	
//-------------------------------------------------
    adg=0;

	AC6613_CAL(hDevice);

	//sam ad data, 0-10V input

	
	ch=0;
	endch=31;
	

	adg=0;

	//sam data ch0-ch15
  do{
    
	if(adg==0)
		printf("\n\nSam Data V=5V\n");
	else if(adg==1)
		printf("\n\nSam Data V=10V\n");
	else if (adg==2)
		printf("\n\nSam Data V=-5V-+5V\n");
	else
		printf("\n\nSam Data V=-10V-+10V\n");

    for(ch=0;ch<=endch;ch++)
    {
       	addata[ch]=AC6613_AD(hDevice,ch,adg);   //delay to wait channel stable, if User want more accuracy
	   
	}


    //dis data and voltage

	for(i=0;i<32;i++)
	{

       
    	v=(double)(addata[i])*5000.0/4095.0;
        
		switch(adg)
		{
		  case 0:
			  v=v;
			  break;
		  case 1:
			  v=v*2;
			  break;

		  case 2:
			  v=v*2-5000.0;
			  break;
		  case 3:
			  v=v*4-10000.0;
			  break;



		}
		printf("CH:%2d  ADG:%1d  Data:%6x     V:%6.1f \n",i,adg,addata[i],v);



	}



	printf("ESC to Quit, other Key to continue....\n");

	//i=0;
	//if(kbhit())
		i=getch();

		if(i=='g')
		{

           adg++;
		   adg=(adg>2) ? 0 : adg;

		}

	}while(i!=27); 



//***************************************************

//---------------------------------pout --------------------------

	AC6613_DO(hDevice,0x0000);
	printf("POUT.......................\n");


	long pdata0=10000;
	long pdata1=1000;

	printf("#0 set 1khz num=1000\n");
	AC6613_PRun(hDevice,0,0,pdata0,pdata1);

	pdata0=10000;
	pdata1=10000;

	printf("#1 set 1khz num=10000\n");
	AC6613_PRun(hDevice,1,0,pdata0,pdata1);

	getch();
	printf("pStop.........\n");

	
	AC6613_PEnd(hDevice,0);
	AC6613_PEnd(hDevice,1);


	getch(); 

	//------------------------------------------------------------------

	//--------------------------------cnt --------------------------------------------
	 
	 printf("\n Testing CNT..........................\n");
  


	 long cwd[2];
 
	 long crd0,crd1;  //read data
	 long trd0,trd1;  //read data


	 long cntch=0;
	 long cntop=0; //op code
 
	 long cop=0; //operation code


	 cwd[0]=1000;
	 cwd[1]=1100;

	 for(cntch=0;cntch<2;cntch++)
	 {

		 printf("ini ch:%d  data=%d....",cntch,cwd[cntch]);
		 AC6613_CNT_Run(hDevice,cntch,cwd[cntch]);
	 }



	 printf("fun return of read %d.....%d\n",AC6613_CNT_Read(hDevice,0,&crd0,&trd0), AC6613_CNT_Read(hDevice,1,&crd1,&trd1));
	 printf("Read cntch0=%d     cntch1=%d   timer : %d   %d\n",crd0,crd1,trd0,trd1);


	 //set DO
	
	AC6613_DO(hDevice,0x3fff);  //high 14,15 is cnt


	 j=1001;
	 printf("gen %d pulse...",j);
	 for(i=0;i<j;i++)
	 {
		 AC6613_DO(hDevice,0x3fff);  //high 14,15 is cnt
		 AC6613_DO(hDevice,0xffff);  //high 14,15 is cnt

	 }

/*
	 //polling st for if freq end
	 do{
              
		 i=AC6613_CNT_Read(hDevice,0,&crd0,&trd0);
		 

	 }while(i!=1) ; //over
 
	 do{
              
		 i=AC6613_CNT_Read(hDevice,1,&crd0,&trd0);
		 

	 }while(i!=1) ; //over
  */  

	 printf("fun return of read %d.....%d\n",AC6613_CNT_Read(hDevice,0,&crd0,&trd0), AC6613_CNT_Read(hDevice,1,&crd1,&trd1));
	 printf("Read cntch0=%d     cntch1=%d   timer : %d   %d\n",crd0,crd1,trd0,trd1);


 
	getch();


//end cnt and pout



//-------------------------USER EEPROM ---------------------------

	sprintf(etmp,"----AC6613 2008/09/10----");
	memcpy(eepdata,etmp,80);
	
	  i=AC6613_EEPROM_WR(hDevice,eepdata);
	  printf("\nwrite User EEPROM :%s  fun ret=%d\n",eepdata, i);
    
	  
      i=AC6613_EEPROM_RD(hDevice,eepdata);
 	  printf("Read EEPRM: %s  Read ret:%d\n",eepdata,i);


	  AC6613_EEPROM_CRD(hDevice,0,32,idata);
      printf("read DA cal data:\n");
	  for(i=0;i<16;i++)
		  printf("%10d",idata[i]);

	  printf("\nchk sum:%d\n",idata[16]);


    getch();

	

  //----------------------------------cal data -------------------------

//	AC6613_RDCAL(hDevice,cdata);
	
//	printf("read cal Befor cal op.....\n");
  //  for(i=0;i<20;i++)
//		printf("%10d",cdata[i]);

    AC6613_CAL(hDevice);
	
	AC6613_RDCAL(hDevice,cdata);
	
	printf("\nread cal After cal op.....\n");
    for(i=0;i<20;i++)
		printf("%10d",cdata[i]);

	printf("\n");
	getch();

    //----------------------------------my tst ----------------------------

    //ad irq
    printf("set ad run.............");

    tdata=100;
	stch=0;
	endch=15;
	adg=0;

	printf("return:%d\n",AC6613_TAD(hDevice,stch,endch,adg,tdata));

    long rdl=0;
    long saml=100000;  //sam total length

    //poll and read fifo
	do{ 

	     //poll length
		 j=AC6613_TAD_Poll(hDevice);

		 if(j<0)
		 {
            printf("FIFO FULL \a\n");
			break;
		 }
		  
		 printf("Poll readl=%d....",j);

		 //read addata
		 i=AC6613_TAD_Read(hDevice,j,&addata[rdl]);
         
		 rdl=rdl+i;

		 printf("read KFIFO:%d    Total:%d\n",i,rdl);


        Sleep(100);
        //if(kbhit())
		//	i=getch();
	 }while(rdl<saml);

	printf("press any key to stop ad...........\n");
	getch();
	
	AC6613_TAD_Stop(hDevice);

  long tmp_ad=0;
  long i1=0;

  tmp_ad=addata[0];

  rdl=0;
  do{

	printf("L=%d   stch:%d  endch:%d ......",rdl,stch,endch);  
	if(adg==0)
		printf("Sam Data V=5V\n");
	else if(adg==1)
		printf("Sam Data V=10V\n");
	else if (adg==2)
		printf("Sam Data V=-5V-+5V\n");
	else
		printf("Sam Data V=-10V-+10V\n");


  for(j=0;j<20;j++)
  {
    //dis data and voltage
	for(i=0;i<(endch-stch+1);i++)
	{

       
    	v=(double)(addata[rdl])*5000.0/4095.0;
		rdl++;
        
		switch(adg)
		{
		  case 0:
			  v=v;
			  break;
		  case 1:
			  v=v*2;
			  break;

		  case 2:
			  v=v*2-5000.0;
			  break;
		 /* case 3:
			  v=v*4-10000.0;
			  break;*/



		}
		printf("%5.0f",v);


		if(i==0)
		{
           //judge sam data
           i1=tmp_ad-addata[rdl-1];

           i1=(i1<0)  ? -1*i1 : i1;

           if(i1>10)
		   {
                 
			   getch();
		   }

		}

	}

	if((endch-stch+1)<16)
		printf("\n");

	
  
  }
    
  //i=getch();
	
//	if(i==27)
//		break;

  }while(rdl<saml);

getch();

//goto ad;
    
	//--------------------------------------------------------------
	//DA




    //**********************************************************
	//   Folling is DA CAL
	//*********************************************************
/*    dag=0;

	//da cal data reg
    long cdaz[16];  //daz  ch0: z5 z10 zb5 zb10   ch1: .....
	long cdaf[16]; //seq is same as cdaz

	printf("DA auto cal..................\n");
	//cal DA
	DACAL_ALL(hDevice,cdaz,cdaf);
	printf("\n");

	//write to eeprom
	//seq:
	//    0   1   2   3   4   5   6  7
	//ch0 z5 f5  z10 f10 zb5 fb5  nc nc     //total 8byte
	//    8  9  10  11  12  13   14   15
	//cha z5


	//ATTENTION !!!! 
	//read or write eeprom by DACAL_EEPROM sub, will update DLL's DA cal Data
 
	  if(( i=DACAL_EEPROM_WR2CH(hDevice,cdaz,cdaf))!=0)
		  printf("write DACAL data to eeprom error! %d\n",i);
	   else
		  printf("write DACAL data to eeprom ok!\n");
	//end write to eeprom



//--------------------------------------------------------	
//dis result
	printf("\n---------------------DA CAL Result --------------------\n");
	
	printf("CHECKED DAZ data\n");
	for(dach=0;dach<2;dach++)
	{
        printf("CH:%d ",dach );
		for(dag=0;dag<3;dag++)
		 {
			printf("%8d",cdaz[dach*4+dag]);
		
		 }
         printf("\n"); 
	}
  
    printf("CHECKED daf data\n");

	for(dach=0;dach<2;dach++)
	{
        printf("CH:%d ",dach );
		for(dag=0;dag<3;dag++)
		 {
			printf("%8d",cdaf[dach*4+dag]);
		
		 }
         printf("\n"); 
	}

		getch();


//--------------------------------------------------------

    //ad ch 20h 28h -> da0 da1

	printf("set DA......................\n");
    
	//read and update cal data
	i=DACAL_EEPROM_RD2CH(hDevice,idata);


	if(i<0)
		printf("read DA EEPROM error %d\n",i);

//end r/w eeprom
	
	
//------------------------------------- tst DA out V--------------------------
	
	dag=2; 
	dach=0;
	long daz,daf;

	do{

	
	  daz=idata[dach*8+dag*2];
	  daf=idata[dach*8+dag*2+1];

	  printf("ch=%d\n",dach);
	  AC6613_DA_Mode(hDevice,dag,dag);
       

	  printf("0V ");
	
	

	   dadata=2048;
	   AC6613_DA(hDevice,dach,dadata);
       
	   Sleep(1);
	   a=DACAL_ADV(hDevice,dach);
	   printf("  AD:%6.0fmV\n",a);
	   
	   getch();

       printf("5V   ");
	   dadata=4095;
	   //dadata=(dadata*(4095-daf))/4095+daz;
	   
	   AC6613_DA(hDevice,dach,dadata);
       
	   Sleep(1);
	   a=a=DACAL_ADV(hDevice,dach);
	   printf("  AD:%6.0fmV\n",a);
	   
	   getch();

	   printf("-5V  ");
	   dadata=0;
	   AC6613_DA(hDevice,dach,dadata);
       
	   Sleep(1);
	   a=a=DACAL_ADV(hDevice,dach);
	   printf("  AD:%6.0fmV\n",a);
	   
	   i=getch();
	
	   dach++;

	   dach=(dach>=2) ? 0 : dach;
	   

	}while(i!=27);
	

//end DA out	
	*/

	
//--------------------------------------------------------
	
//ad:
	
	
	

//-------------------------------------------------
    adg=0;

	AC6613_CAL(hDevice);

	//sam ad data, 0-10V input

	
	ch=0;
	endch=31;
	

	adg=0;

	//sam data ch0-ch15
  do{
    
	if(adg==0)
		printf("\n\nSam Data V=5V\n");
	else if(adg==1)
		printf("\n\nSam Data V=10V\n");
	else if (adg==2)
		printf("\n\nSam Data V=-5V-+5V\n");
	else
		printf("\n\nSam Data V=-10V-+10V\n");

    for(ch=0;ch<=endch;ch++)
    {
       	addata[ch]=AC6613_AD(hDevice,ch,adg);   //delay to wait channel stable, if User want more accuracy
	   
	}


    //dis data and voltage

	for(i=0;i<32;i++)
	{

       
    	v=(double)(addata[i])*5000.0/4095.0;
        
		switch(adg)
		{
		  case 0:
			  v=v;
			  break;
		  case 1:
			  v=v*2;
			  break;

		  case 2:
			  v=v*2-5000.0;
			  break;
		  case 3:
			  v=v*4-10000.0;
			  break;



		}
		printf("CH:%2d  ADG:%1d  Data:%6x     V:%6.1f \n",i,adg,addata[i],v);



	}



	printf("ESC to Quit, other Key to continue....\n");

	//i=0;
	//if(kbhit())
		i=getch();

		if(i=='g')
		{

           adg++;
		   adg=(adg>3) ? 0 : adg;

		}

	}while(i!=27); 
	
	//close device
	printf("\n\nclose device=%d(0:ok -1:error)\n",AC6613_CloseDevice(hDevice));
	printf("end!\n");
    getch()	;


  
	return 0;


}





void setch(long stch,long endch,long adg,long bip,long sidi)
{
	
	long ch;

	
	adg=adg & 0x3;
    endch=endch & 0x3f;
    sidi=sidi & 1;
	bip=bip & 1;

	//set ch
	ch=stch & 0x3f;
	ch=ch | (endch<<8);
    
	//set adg
	ch=ch | (adg<<6);
	
	//set sidi
	ch= ch | (sidi<<15) ;
	
    //set bip
	ch=ch | (bip<<14);
	
	printf("ch=%x adg=%x........",ch,adg);
	//set ch
	AC6613_outw(hDevice,0,ch);

}




/*

	//clr 
	printf("adrun return %d\n",AC6613_wdm_adrun(hDevice,0,0,0,0));

	//clr irq
	//AC6613_inb(hDevice,5);
	printf("st=%x\n",AC6613_inb(hDevice,0));

	//rew clr fifio
    

	//enable irq and adeb
	AC6613_outb(hDevice,0x4,0x80);

    printf("irq eb............\n");

	//for IOCTL using
	//long bufInput[512];
	//long bufOutput[512];
    //ULONG nOutput;
    long flen,ff,kfst,stmp;

	long wcnt=0;

	do{
	
		for(i=0;i<1000;i++) //write byte to fifo
        {
			AC6613_outb(hDevice,0x2,i & 0xff);	
		    wcnt++;
		}
		Sleep(10);

    printf("\n----------------------------------------------\n");
	AC6613_fifo_poll(hDevice,&flen,&ff,&kfst,&stmp);

    printf("kflen:%d   ff:%d   kfst:%d   tmpdata:%d\n",flen,ff,kfst,stmp);
	//printf("\n");
    

	if(ff<0)
		getch();

	//rea fifo Len
	i=AC6613_inw(hDevice,0xc);
	printf("FIFO ST=%x   Len=%d\n",i>>14,i & 0xfff);
	
	
	printf("rea fifo data len=%d\n",	AC6613_wdm_rkfifo(hDevice,1000,data));
	
	printf("read 1st 512....\n");
	for(i=0;i<256;i++)
		printf("%5x",data[i]);

	AC6613_fifo_poll(hDevice,&flen,&ff,&kfst,&stmp);

    printf("kflen:%d   ff:%d   kfst:%d   tmpdata:%d\n",flen,ff,kfst,stmp);
	
	

	i=getch();
	}while(i!=27);

   //disable irq
	AC6613_outb(hDevice,0x4,0x0);






   getch();


   exit(0);




  */