// WWlabFunction.h: interface for the CWWlabFunction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_)
#define AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWWlabFunction  
{
public:
	double WWLAB_DAV(long dag, long dadata);
	double WWlab_ADV(long gain, long addata);
	long WWlab_DA_WStop(HANDLE hDevice);
	long WWlab_DA_WRun(HANDLE hDevice ,long dag,  long wdal, long wdat, long *dadata);

	HANDLE phDevice;

	long WWlab_PAD(HANDLE hDevice,long ch,long gain, long sidi);
	
	//忨̬⺯
	HANDLE WWlab_OpenDevice(long num);             //򿪾
	long WWlab_CloseDevice(HANDLE hDevice);        //رվ

	//EEprom
	long WWlab_EEPROM_Write(HANDLE hDevice, unsigned char *wbuf);
	long WWlab_EEPROM_Read(HANDLE hDevice, unsigned char *rbuf);

	long WWlab_EEPROM_S_Write(HANDLE hDevice, unsigned char *wbuf);
	long WWlab_EEPROM_S_Read(HANDLE hDevice, unsigned char *rbuf);
	
	//AD
	long WWlab_AD_Cal(HANDLE hDevice);
	long WWlab_AD_Run(HANDLE hDevice,void *adset);
	long WWlab_AD_Read(HANDLE hDevice, long rdlen,long *rdata);
	long WWlab_AD_Poll(HANDLE hDevice);
	long WWlab_AD_Stop(HANDLE hDevice);
	
	//DA
	long WWlab_DA(HANDLE hDevice,long dach,long dag,long dadata);
	long WWlab_DA_Mode(HANDLE hDevice,long gs0,long gs1);


	//DIO
	long WWlab_DO(HANDLE hDevice, long dodata);
	long WWlab_DI(HANDLE hDevice);

	
	//ʱ
	long WWlab_CNT_Run(HANDLE hDevice, long cntch, long cdata);
	long WWlab_CNT_Read(HANDLE hDevice, long cntch,long *cdata, long *tdata);


	//庯
	long WWlab_PRun(HANDLE hDevice,long pch, long pmode,long pdata0, long pdata1);
	long WWlab_PState(HANDLE hDevice,long pch);
	long WWlab_PEnd(HANDLE hDevice,long pch);
	long WWlab_inb(HANDLE hDevice, long adr);
    long WWlab_outb(HANDLE hDevice, long adr, long data);
	long WWlab_ResetUSB(HANDLE hDevice);

	
	//AD
	struct m_adset
	{
		//ad star channel, end channel,si or di input sel, gain=0,1,2,3
		int stch;
		int endch;	
		int gain;
		int sidi;
		int sammode;
		int trsl;
		int trpol;
		int clksl;
		int clkpol;
		int tdata;
		
	};

	
	
	CWWlabFunction();
	virtual ~CWWlabFunction();



};

#endif // !defined(AFX_WWLABFUNCTION_H__CF6FFF9D_3ABD_4E7C_8458_2636767C69CF__INCLUDED_)
