/////////////////////////////////////////////////////////////////
//AC6613 include files
//wwlab (c)2006/11   by york wang


//for DIO
extern "C" long __declspec(dllimport) __stdcall AC6613_DI(HANDLE hHandle);
extern "C" long __declspec(dllimport) __stdcall AC6613_DO(HANDLE hHandle,long iodata);

//for AD
extern "C" long __declspec(dllimport) __stdcall AC6613_AD(HANDLE hDevice,long adch,long adg);
extern "C" long __declspec(dllimport) __stdcall AC6613_CAL(HANDLE hDevice);

extern "C" HANDLE __declspec(dllimport) __stdcall AC6613_OpenDevice(long DeviceNum);
extern "C" long __declspec(dllimport) __stdcall AC6613_CloseDevice(HANDLE hHandle);

//----------------------------------------------------------------------------------------------------
//da
//data=0-4095  ch=0-3 via DA ch0-ch3
extern "C" long __declspec(dllimport) __stdcall AC6613_DA(HANDLE hHandle,long ch,long dadata);
//set DA mode, dg=0,1,2 out=5V/10V/B5V
extern "C" long __declspec(dllimport) __stdcall AC6613_DA_Mode(HANDLE hHandle,long dag0, long dag1);

//read 32byte EEPROM Data
extern "C" long __declspec(dllimport) __stdcall AC6613_EEPROM_RD(HANDLE hDevice,unsigned char *rdata);
//write 32byte data to EEPROM
extern "C" long __declspec(dllimport) __stdcall AC6613_EEPROM_WR(HANDLE hDevice, unsigned char *wdata);



//---------------------------AD timer Mode ---------------------------------------------
//stop ad
extern "C" long __declspec(dllimport) __stdcall AC6613_TAD_Stop(HANDLE hDevice);
//start ad
extern "C" long __declspec(dllimport) __stdcall AC6613_TAD(HANDLE hDevice,long stch,long endch,long adg, long tdata);

//read data from sys buffer
//read len=rdlen, and rdlen must<= TAD_Poll return length
//read data is send to addata, and addata size must > rdlen!!!
//return real read length, if <0 , FIFO FUll
extern "C" long __declspec(dllimport) __stdcall AC6613_TAD_Read(HANDLE hDevice, long rdlen, long *addata);
//poll user read length of AD, return >=0 ok, return -1 FIFO error
//read length return by flen
extern "C" long __declspec(dllimport) __stdcall AC6613_TAD_Poll(HANDLE hDevice);



//------------------------------------for cnt and pout -------------------------------------------
//stop pulse out
extern "C" long __declspec(dllimport)  __stdcall AC6613_PEnd(HANDLE hDevice,long pch);

//start pout and set out eb
//pch =0,1
//pmode: 0 PWM mode / 1 single pulse mode
//PWM mode: pdata0 cycle / padat1 high wideth
extern "C" long __declspec(dllimport)  __stdcall AC6613_PRun(HANDLE hDevice,long pch, long pmode,long pdata0, long pdata1);

//return out state, =1 out =1 / =0 out =0
extern "C" long __declspec(dllimport)  __stdcall AC6613_PState(HANDLE hDevice,long pch);

//set timer data
extern "C" long __declspec(dllimport)  __stdcall AC6613_PSetData(HANDLE hDevice,long pch,long pdata0, long pdata1);

//read data: cnt data cdata / timer data tdata
//return: <0 error / =0 cnt not over / =1 cnt over
extern "C" long __declspec(dllimport)  __stdcall AC6613_CNT_Read(HANDLE hDevice,long cntch, long *cdata, long *tdata);

//run or start cnt ch
//cdata: initla cnt data
extern "C" long __declspec(dllimport)  __stdcall AC6613_CNT_Run(HANDLE hDevice, long cntch, long cdata);

//end


//--------------------------------------not for user ------------------------------------------
extern "C" long __declspec(dllimport) __stdcall AC6613_inb(HANDLE hDevice,long adr);
extern "C" long __declspec(dllimport) __stdcall AC6613_inw(HANDLE hDevice,long adr);
extern "C" long __declspec(dllimport) __stdcall  AC6613_outb(HANDLE hDevice,long adr,long data1);
extern "C" long __declspec(dllimport) __stdcall  AC6613_outw(HANDLE hDevice,long adr,long data1);


extern "C" long __declspec(dllimport) __stdcall AC6613_EEPROM_CRD(HANDLE hDevice,long adr, long len , long *rdata);
extern "C" long __declspec(dllimport) __stdcall AC6613_EEPROM_CWR(HANDLE hDevice,long adr, long len , long *wdata);


extern "C" long __declspec(dllimport)  __stdcall AC6613_RDCAL(HANDLE hDevice,long *caldata);
extern "C" long __declspec(dllimport)  __stdcall AC6613_WRCAL(HANDLE hDevice,long *caldata);
extern "C" long __declspec(dllimport) __stdcall  AC6613_sam(HANDLE hDevice,long ch,long *cdata);

//for cal set DA
extern "C" long __declspec(dllexport) __stdcall AC6613_DA_CSET(HANDLE hDevice,long ch,long dadata);

//poll kfifo
extern "C" long __declspec(dllexport) __stdcall AC6613_fifo_poll(HANDLE hDevice,long *flen, long *ff, long *kfifost, long *tmp);
extern "C" long __declspec(dllexport) __stdcall AC6613_wdm_adrun(HANDLE hDevice,long adch,long admode,long tdata);
extern "C" long __declspec(dllexport) __stdcall AC6613_wdm_rkfifo(HANDLE hDevice, long rdl , long *data);


extern "C" long __declspec(dllexport) __stdcall AC6613_AD_CSAM(HANDLE hDevice,long adch,long adg);
