

//opem AC6022
extern "C" HANDLE __declspec(dllimport)  __stdcall AC6022_OpenDevice(__int32 dev_num);
//close device
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_CloseDevice(HANDLE hDevice1);


//****************************************************************************
//for AD

//*****************************************************************
//sam a single channel with average times=naver
//ch=0-15 , selected input
//gain: selected input range, 0,1,2,3 via: 10/5/2.5/1.25V, 4,5,6,7 via: B10/B5/B2.5/B1.25V
//sidi: not using by AC6022
//return data=0-4095, 12bit ad data, if -1 error
//naver: average times, =0-100, if 0 aver times=1
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_AD(HANDLE hDevice,__int32 ch,__int32 gain,__int32 sidi);


//Cal AD for Gain=gain, return zero data zdata, gain data: gdata
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_CAL(HANDLE hDevice);

//counting ad's voltage
extern "C" double __declspec(dllimport) __stdcall AC6022_ADV(__int32 adg,__int32 addata);

//-----------------------------------tad mode--------------------------
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_TAD_Read(HANDLE hDevice, __int32 rlen,__int32 *addata);
//extern "C" long __declspec(dllexport) __stdcall AC6022_TAD_Read(HANDLE hDevice, long rdlen, long *addata)

//return fifo's ad data length
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_TAD_Poll(HANDLE hDevice);
//extern "C" long __declspec(dllexport) __stdcall AC6022_TAD_Poll(HANDLE hDevice)

//start tad
//tdata =50 - 65536 , base clk 1uS
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_TAD(HANDLE hDevice,__int32 stch,__int32 endch,__int32 gain,__int32 sidi,__int32 tdata);
//extern "C" long __declspec(dllexport) __stdcall AC6022_TAD(HANDLE hDevice,long stch,long endch,long adg, long sidi, long tdata)

//stop AD
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_TAD_Stop(HANDLE hDevice);
//end AD

//****************************************************************************
//DIO
//get 16bit DI data, data return by AC6022_DI
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_DI(HANDLE hDevice);
//set 16bit DO data=dodata
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_DO(HANDLE hDevice,__int32 dodata);

//****************************** EEPROM ********************************************************************
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_EEPROM_RD(HANDLE hDevice,unsigned char *rbuf);
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_EEPROM_WR(HANDLE hDevice, unsigned char *wbuf);



//*****************************************************************************************************
//DA


//****************************************************************************************************
///--------------------------for Counter and Pulse  Out ------------------------------------
//------------------------------------for cnt and pout -------------------------------------------
//stop pulse out
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_PEnd(HANDLE hDevice,__int32 pch);

//start pout and set out eb
//pch =0,1
//pmode: 0 PWM mode / 1 single pulse mode
//PWM mode: pdata0 cycle / padat1 high wideth
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_PRun(HANDLE hDevice,__int32 pch, __int32 pmode,__int32 pdata0, __int32 pdata1);

//return out state, =1 out =1 / =0 out =0
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_PState(HANDLE hDevice,__int32 pch);

//set timer data
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_PSetData(HANDLE hDevice,__int32 pch,__int32 pdata0, __int32 pdata1);

//read data: cnt data cdata / timer data tdata
//return: <0 error / =0 cnt not over / =1 cnt over
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_CNT_Read(HANDLE hDevice,__int32 cntch, __int32 *cdata, __int32 *tdata);

//run or start cnt ch
//cdata: initla cnt data
extern "C" __int32 __declspec(dllimport)  __stdcall AC6022_CNT_Run(HANDLE hDevice, __int32 cntch, __int32 cdata);

//end


//****************************************************************************************************************
//for EXP IO CARD IO

//read exp card 16bit data
extern "C" __int32 __declspec(dllimport) __stdcall AC6022_MPERD16(HANDLE hDevice,__int32 cardn,__int32 cmd);

//wr exp , write 16bit data 0-65535, if return  <0 error
extern "C" __int32 __declspec(dllimport) __stdcall AC6022_MPEWR16(HANDLE hDevice,__int32 cardn,__int32 cmd, __int32 wdata);