// Draw.cpp: implementation of the CDraw class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Draw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include "MemDC.h"//ڴ滭ͼ
#include "mSetData.h" //all max min hardware data
#include "WWlabFunction.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CWWlabFunction wwfunc;

CDraw::CDraw()
{

}

CDraw::~CDraw()
{

}

void CDraw::DrawGird(CDC* dc,CRect rc,int FontNum)
{
	CFont Font1,Font2;
	Font1.CreateFont(FontNum, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,"Verdana");
	Font2.CreateFont(FontNum*3/4, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,"Verdana");
	//û
	CPen* pPenGreen = new CPen;
	CPen* pPenRed=new CPen;
	
	pPenGreen->CreatePen(PS_DOT,1,RGB(0,255,0));
	pPenRed->CreatePen(PS_SOLID,1,RGB(255,0,0));
	
	//XY ѡɫ
	dc->SelectObject(pPenGreen);
	int s;
	for (s = 0 ;s <= 14 ;s++)
	{
		if(s!=7)//ƽy
		{
			dc->MoveTo(rc.Width()/100+s*rc.Width()*49/14/50,rc.Height()/75);
			dc->LineTo(rc.Width()/100+s*rc.Width()*49/14/50,rc.Height()*74/75);
		}
		
		if(s<=10 && s!=5)//ƽx
		{
			dc->MoveTo(rc.Width()/100,rc.Height()*1/75+s*rc.Height()*73/75/10);
			dc->LineTo(rc.Width()/100+rc.Width()*49/50,rc.Height()*1/75+s*rc.Height()*73/75/10);
		}
	}
	delete pPenGreen;
	
	
	dc->SelectObject(pPenRed);//ɫXY
	//x
	dc->MoveTo(rc.Width()/100, rc.Height()/2);
	dc->LineTo(rc.Width()/100+14*rc.Width()*49/14/50, rc.Height()/2);
	
	//XY̶
	for(int j=0; j<=70; j++)
	{
		if((j%5)==0)
		{
			dc->MoveTo(rc.Width()/100+14*rc.Width()*49/14/50*j/70, rc.Height()/2-rc.Height()/2*6/200);
		}
		else
		{
			dc->MoveTo(rc.Width()/100+14*rc.Width()*49/14/50*j/70, rc.Height()/2-rc.Height()/2*3/200);
		}
		dc->LineTo(rc.Width()/100+14*rc.Width()*49/14/50*j/70, rc.Height()/2);
		
		if(j<=50 && j!=25)
		{
			if((j%5)==0)
			{
				dc->MoveTo(rc.Width()/100+7*rc.Width()*49/14/50+rc.Width()*4/500, rc.Height()/75+rc.Height()*73*j/75/50);
			}
			else
			{
				dc->MoveTo(rc.Width()/100+7*rc.Width()*49/14/50+rc.Width()*2/500, rc.Height()/75+rc.Height()*73*j/75/50);
			}
			dc->LineTo(rc.Width()/100+7*rc.Width()*49/14/50, rc.Height()/75+rc.Height()*73*j/75/50);
		}
	}
	
	//y
	dc->MoveTo(rc.Width()/100+7*rc.Width()*49/14/50,rc.Height()/75);
	dc->LineTo(rc.Width()/100+7*rc.Width()*49/14/50,rc.Height()*74/75);
	
	delete pPenRed;
}


//ѹ
//ch is channel of AD
//G ad gain
//num is: number of total ad ch
void CDraw::DrawAD(CDC* dc,CRect rc,long *DrawBuff,int OffsetCH,int G,int num)
{
	int y;
	
	for(int i=0; i<wave_xlen; i++)
	{	
	    y=0;
//ac6624 only has bip mode
		if(G<=1)
		{
			y=(DrawBuff[OffsetCH+num*i]*((rc.Height())*36/75))/4095;  //UNI
			DrawVol(dc,rc,i,y);
		}
		else
		{
			y=(DrawBuff[OffsetCH+num*i]-2048)*((rc.Height())*36/75)/2048;  //Bip
			DrawVol(dc,rc,i,y);
		}
	}

}


//ѹת
void CDraw::DrawVol(CDC* dc,CRect rc,int i,int y)
{	
	
	if(y>=rc.Height()*36/75)
		y=rc.Height()*36/75;
	if(y<=-rc.Height()*36/75)
		y=-rc.Height()*36/75;

	if(i==0)
	{
		dc->MoveTo((wave_xlen-i)*14*rc.Width()*49/14/50/wave_xlen+rc.Width()/100,(rc.Height()/2-y));
	}
	
	dc->LineTo((wave_xlen-i)*14*rc.Width()*49/14/50/wave_xlen+rc.Width()/100,(rc.Height()/2-y));

}


//   str0                         str1
//                                str2

#define posx_str0  2   //ratio of position 
#define posy_str0  2   //ratio of position 
#define posx_str1  90   //ratio of position 
#define posy_str1  2   //ratio of position 
#define posx_str2  90   //ratio of position 
#define posy_str2  4   //ratio of position 

//level at mV
void CDraw::DrawTextMessage(CDC* dc,CRect rc,int stch, int endch,int gain,int sidi,int sammode,int timer)
{
	//ʾϢ
	CString Vol;
	CString aa;
	CString Sidi;
	CString Sammode;
	Vol="";

	//double trlevel=0;
	//int trmode=0;
	
//----------------------------------!!!! user must changed ------------------------

	int CHNumber=endch-stch+1;

	switch(gain)
	{
	case 0:
	//	Vol.Format("%3.1fV/div",fs_un/5);  //g=1
		Vol.Format("%4.2fV/div",fs0_v/5);  //g=0 B10V
		aa=gain_str0;
		break;
	case 1:
	//	Vol.Format("%3.1fV/div",fs_un/5/2);  //g=2
		Vol.Format("%4.2fV/div",fs1_v/5);  //g=0 10V
		aa=gain_str1;
		break;
	case 2:
	//	Vol.Format("%3.1fV/div",fs_un/5/4);  //g=2
		Vol.Format("%4.2fV/div",fs2_v/5);  //g=0 B5V
		aa=gain_str2;
		break;
	case 3:
	//	Vol.Format("%3.1fV/div",fs_un/5/8);  //g=4
		Vol.Format("%4.2fV/div",fs3_v/5);  //g=0 B10
		aa=gain_str3;
		break;
	case 4:
		Vol.Format("%3.1fV/div",fs_bip/5/1);  //g=1
		aa=gain_str4;
		break;
	case 5:
		Vol.Format("%3.1fV/div",fs_bip/5/2);  //g=2
		aa=gain_str5;
		break;
	case 6:
		Vol.Format("%3.1fV/div",fs_bip/5/4);  //g=4
		aa=gain_str6;
		break;
	case 7:
		Vol.Format("%3.1fV/div",fs_bip/5/8);  //g=8
		aa=gain_str7;
		break;
	}
	
	dc->SetTextColor(RGB(150,150,150));
	dc->TextOut(rc.Width()/100*posx_str1,rc.Height()/75*posy_str1,Vol);

	if(sidi!=0)
	{
		Sidi="";
	}
	else
    {	
		Sidi="";
	}


	double sp1; //speed
	sp1=(double)ad_baseclk/(double)timer/1000.0;  //Hz -> KHZ

	if(sammode!=0)
	{
		Sammode="SH";
		Vol.Format("CH:%2d-%2d  %s   %s  %s Mode  AD SP.%6.1fKhz/CH",stch,endch,aa,Sidi,Sammode,sp1);
	}
	else
    {	
		Sammode="Normal";
		Vol.Format("CH:%2d-%2d  %s   %s  %s Mode  AD SP.%6.1fKhz/CH",stch,endch,aa,Sidi,Sammode,sp1/CHNumber);
	}
	

	dc->TextOut(rc.Width()*posx_str0/100,rc.Height()*posy_str0/75,Vol);

	
	//------------------------------------------------------------------
    //time base dis
	CString TimeY;
	double T_clk;
	T_clk=(double)timer *(1000000.0/(double)ad_baseclk); //timer's uS 
	T_clk=T_clk*(double)wave_xlen/14.0/1000.0; //DIV mS, 14 big secetion at X ax. and have wave_xlen ad samples
	

	if(sammode==1)
	{
		TimeY.Format("%.3fms / div",T_clk);
	}
	else
	{	
		TimeY.Format("%.3fms / div",T_clk*CHNumber);
	}
	
	dc->TextOut(rc.Width()/100*posx_str2,rc.Height()/75*posy_str2+10,TimeY);

	
	//------------------------------------------------------------------
	//ch
	CString tmp1,tmp;
	tmp="";
	
	for(int i=stch;i<=endch;i++)
	{
		if(i<16)
		{
			dc->SetTextColor(SetColor(i));
		    tmp1.Format("%2d  ",i); 
		    dc->TextOut(rc.Width()*2*i*3/100+11,rc.Height()*70/75-10,tmp1);
		}
		else
		{
	        dc->SetTextColor(SetColor(i));
		    tmp1.Format("%2d  ",i); 
		    dc->TextOut(rc.Width()*2*(i-16)*3/100+11,rc.Height()*70/75+5,tmp1);

		}
	}

}


//øͨɫ
// input =-1 , set color is bkcolor
COLORREF CDraw::SetColor(int SampleChannel)
{
	int R;
	int	G;
	int B;
	switch(SampleChannel)
	{
	
		case -1:	//bk color for ease line
		R=0;
		G=0;
		B=0;
		break;
	
	
	case 0:	//
		R=255;
		G=0;
		B=0;
		break;
	case 1:	//ɫ
		R=0;
		G=255;
		B=0;
		break;
	case 2:	//
		R=255;
		G=255;
		B=0;
		break;
	case 3:	//ɫ
		R=255;
		G=255;
		B=255;
		break;
	case 4:	//ɫ
		R=0;
		G=255;
		B=255;
		break;
	case 5:	//
		R=255;
		G=0;
		B=255;
		break;
	case 6:	//
		R=00;
		G=0xbf;
		B=255;
		break;
	case 7:	//ǳ
		R=0xff;
		G=0xd7;
		B=0x00;
		break;
	case 8:	//
		R=0xc0;
		G=255;
		B=0x3e;
		break;
	case 9:	//
		R=255;
		G=255;
		B=192;
		break;
	case 10://Һ	
		R=0xff;
		G=0x14;
		B=0x93;
		break;
	case 11://	
		R=5;
		G=186;
		B=134;
		break;
	case 12://	
		R=0xee;
		G=0xae;
		B=0xee;
		break;
	case 13://	
		R=0x9a;
		G=255;
		B=0x9a;
		break;
	case 14://	
		R=0x83;
		G=0x6f;
		B=255;
		break;
	case 15://	ϻ
		R=0xad;
		G=0xd8;
		B=0xe0;
		break;


		default:
		{
           R=100;//(SampleChannel-15)*2+100;
		   G=255/16*(SampleChannel-15);
		   B=255/8*(SampleChannel-15);

		   R=(R>255) ? 255: R;
		   R=(R<0) ? 0: R;

		   G=(G>255) ? 255: G;
		   G=(G<0) ? 0: G;
		   
		   B=(B>255) ? 255: B;
		   B=(B<0) ? 0: B;

		}
	}
	



		return RGB(R, G, B);

}



//12λAD
double CDraw::Convert(int gain, int SampleData)
{
	double Voltage;
	
	CWWlabFunction mfunc;

	Voltage=mfunc.WWlab_ADV(gain,SampleData);
	return Voltage;
	
}

void CDraw::Drawtrlevel(CDC *dc, CRect rc, int trlevel, int  trmode, int adg)
{
	
	int x,y;
	CString Vol;
	double v;

	CWWlabFunction mfunc;
	
	//------------------------------------------------------------------------
	//tr level line

	CDraw::SetColor(15);

	y=(trlevel-2047)*((rc.Height())*36/75)/2048;  //Bip

	if(y>=rc.Height()*36/75)
		y=rc.Height()*36/75;
	
	if(y<=-rc.Height()*36/75)
		y=-rc.Height()*36/75;

	x=0;
	
	dc->MoveTo(rc.Width()/100,(rc.Height()/2-y));
	dc->LineTo( (wave_xlen*14*rc.Width()*49)/14/50/wave_xlen+rc.Width()/100,(rc.Height()/2-y));


   //------------------------------------------------------------------
   //set trig dis

    v=mfunc.WWlab_ADV(adg,trlevel<<4);

	if(trmode==0)
	   Vol.Format("TR.Level:%6.0fmV  ", v);
	else
	   Vol.Format("TR.Level:%6.0fmV  ½", v);

	//dis text
	dc->SetTextColor(RGB(170,170,170));
	dc->TextOut(rc.Width()/100+5,rc.Height()/75*posy_str2+10,Vol);

}
